import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import java.lang.*;


  /* The big idea is as follows:
     module creates a server socket and sends its port number here (p)
     (message with format PUTX, where X is the port number)
     then the controls connect with message GET which is responded to by
     sending the value of p (converted to a a string).
     Now, it may happen that the controls connects before the module,
     therefore p is initialised to 0, and reset to 0 as soon as it is sent.
     This way p=0 unless the module deposited a new port number.
     Controls is supposed to keep trying till p != 0, therefore connection
     is implemented as a separate thread.
     This servr is implemented as a separate thread in order not to block
     WebEdit.
     In the future, this server should be implemented as a servlet
     */


public class PortServlet extends GenericServlet implements Runnable
{
  public final static int DEFAULT_PORT=5500;
  protected int port=0;
  protected ServerSocket listen_socket;
  public static Integer p = new Integer(0);
  Thread socketThread;
  String hostName;
  int    portNumber;
  int counter=0;
  SwingServlet swingservlet;     
  public static String DocumentRoot=null;
  
  public void init(ServletConfig Params) throws ServletException
  {
    //Erol
    swingservlet = new SwingServlet();
    //Erol

    int port=0;
        
    //System.out.println("Module Manager accessed");
    try {
          super.init(Params);
    } catch (ServletException e)
      {  System.out.println(" Exception in init() of MM ");
         e.printStackTrace();
      }
 
    String portString = Params.getInitParameter("Port");
    if (portString != null)
       port = Integer.parseInt(portString);
    
    //-----
    if(port==0) port = DEFAULT_PORT;
    this.port=port;
    try { listen_socket = new ServerSocket(port);}
    catch (IOException e) {fail(e,"Exception creating server socket");}

    //Erol additions
    try{
      listen_socket.setSoTimeout(1);
    }catch(SocketException e){
      System.out.println("SocketException :"+e);
    }
    //Erol additions

    //System.out.println("Server: listening on port " + port);
    //-----

    // finally, branch new thread, set it up as a deamon (to terminate
    // upon completion of master program), and start it up
    socketThread = new Thread(this);
    socketThread.setDaemon(true);
    socketThread.start();
  
    portNumber = port;
    try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
    }catch(UnknownHostException e)
    {  hostName = "0";
       //System.out.println(" UnknownHostException in init() of MM ");
       e.printStackTrace();
    }
 
       
 }
  
public void testSomething(ServletRequest req)
  {
    System.out.println("This servlet has the following atts:");
    String docRoot = (String)
      req.getAttribute("org.apache.jserv.DOCUMENT_ROOT");
    String serverName = (String)
      req.getAttribute("org.apache.jserv.SERVER_NAME");
    String serverPort = (String)
      req.getAttribute("org.apache.jserv.SERVER_PORT");
    
    System.out.println("DocRoot:"+docRoot);
    System.out.println("Servername:"+serverName);
    System.out.println("ServerPort:"+serverPort);
        
  }
  


  
  public static void fail(Exception e, String msg) {
    System.err.println(msg+":"+e);
    System.exit(1);
  }

  public void run() 
  {
    while(true) {
      try{
	Socket client_socket = listen_socket.accept();
	Connection c = new Connection(client_socket);
      }catch(InterruptedIOException e){
	//System.out.println("InterruptedIOException  ");
      }catch(IOException e){
	System.out.println("IOException during accepting clinet ");
      }
      swingservlet.checkin();
    }
  }
  
    
  public void service(ServletRequest req, ServletResponse res)
       throws ServletException, IOException
  {

  
        counter++;
    
        res.setContentType("text/plain");
        OutputStream os = res.getOutputStream();
        PrintStream out = new PrintStream( os );
        out.println(hostName);
        out.println(portNumber);
        out.println("EROL:counter:"+counter);
        out.flush();

	String s = req.getParameter("filename");
        out.println("param :"+s);
    
	DocumentRoot = (String)req.getAttribute("org.apache.jserv.DOCUMENT_ROOT");
	
  }
  
}

class Connection extends Thread {
protected Socket client;
protected DataInputStream dis;
protected DataOutputStream dos;
  String m1;
  int aport;
  Integer p;

  public Connection(Socket client_socket) {
  client = client_socket;
  try {
        dis = new DataInputStream(client.getInputStream());
        dos = new DataOutputStream(client.getOutputStream());
  }
  catch (IOException e) {
         try {client.close();}
         catch (IOException e2) {;}
         System.err.println("Exception while getting socket streams: " + e);
         return;
  }
  this.start();
  }
  
  public void run() 
  {
         String line;
         StringBuffer revline;
         int len;

	   String message = receive();
           if(message.startsWith("PUT")) {
              m1 = message.substring(3);
              System.out.println("register port "+m1); 
              PortServlet.p = new Integer(m1);
              aport = PortServlet.p.intValue(); 
	   }
	   else if(message.startsWith("GET")) {
             send(PortServlet.p.toString());
             PortServlet.p = new Integer(0);      
	   }
	   else{
	     System.out.println("unknown request to the PortServer");
	   }
	   
	   try {
	     client.close();
	   }  catch (IOException e2) {;}
  }
  

  public void send(String message){

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 
     System.out.println("Trying to send... "+message);

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
           dos.flush();
          } catch(IOException e) {System.out.println(e);}
}

     public String receive(){
     String message = "";
     try{
        int ls=dis.readInt();
	System.out.println("strlen "+ls);
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
	       System.out.println("I have received from Applet: "+message);
        } catch(IOException e){
          System.out.println(e);
          stop();
        }
	return(message);
     }
  
}

class SwingServlet
{
public int WFEPort = 5505;
public ServerSocket WFESock;
public Socket []socket_list = new Socket [16];
public ObjectOutputStream []oos_list = new ObjectOutputStream[16];
public ObjectInputStream []ois_list  = new ObjectInputStream[16];  
public DataInputStream []dis_list  = new DataInputStream[16];  
  int socketCounter =0;
  
 public  SwingServlet() 
   {
 
      try{
	WFESock = new ServerSocket(WFEPort);
	WFESock.setSoTimeout(1);
      }catch(IOException e){
	System.out.println("SwinServlet could not open port:"+WFEPort+":"+e);
      }
      for(int k = 0;k<16;k++){
	socket_list[k]=null;
	oos_list[k] = null;
	ois_list[k] = null;
	dis_list[k] = null;
      }
   }
  

 public void checkin  () 
  {
    boolean flag = true;
    
    //    while(flag) {
      try{   
	Socket s = WFESock.accept();
	oos_list[socketCounter] = new ObjectOutputStream(s.getOutputStream());
	ois_list[socketCounter] = new ObjectInputStream(s.getInputStream());
	dis_list[socketCounter] = new DataInputStream(s.getInputStream());
	System.out.println("client connected !!"+oos_list[socketCounter]+
			   "&&"+ois_list[socketCounter]);

	socket_list[socketCounter++]  = s;
      }catch(InterruptedIOException e){
       //System.out.println("InterruptedIOException during accepting clinet ");
      }catch(IOException e){
	System.out.println("IOException during accepting clinet ");
      }
   
      for(int k=0;k < socketCounter; k++){
	try{
	  if ((dis_list[k] != null) && (dis_list[k].available() > 0))
	    {
	      processWFECommand(k);
	    }
	  }catch ( IOException e ) 
	    {
	      System.out.println( "IOException(run): " + e.toString() );
	    }
      }
      
      // } (while)
  }
  
public void  processWFECommand(int k)
  {
  
    System.out.println("processWFECommand :k:"+k);
    
      String message = receive(ois_list[k]);
      
      if (message.startsWith("GetGML")){
	//get the file with name "filename" and send it
	String filename = message.substring("GetGML".length());
	filename = PortServlet.DocumentRoot+"/"+filename;
	String buf = readFile(filename);
	send(buf,oos_list[k]);
      }
      else if (message.startsWith("StoreGML")){
	//store the file in "buf" into the file with name "filename"
	String filename = message.substring("StoreGML".length());
	filename = PortServlet.DocumentRoot+"/"+filename;
	String buf      = receive(ois_list[k]);
	writeFile(filename,buf);
      }
      else if (message.startsWith("SWING_REQ")){
	//give the directory list to applet
	String filename = message.substring("SWING_REQ".length());
	filename = PortServlet.DocumentRoot+"/"+filename;
	System.err.println("I received DIR NAME:"+filename);
	String []dir_content=null;
	try{
	  dir_content = list(filename,"");
	}catch(InterruptedException e){	}
	send_directory_contents(dir_content,oos_list[k]);
      }
  }
  
public void send_directory_contents(String []list,ObjectOutputStream dos)
  {
    
    send(list[0],dos);
    int nfiles = list.length-1;
    send(Integer.toString(nfiles),dos);
    
    for(int i=1;i<list.length;i++)
      send(list[i],dos);

  }

public  String [] list(String dir,String opts)
         throws InterruptedException
  {
    boolean isExist=false,isRead=false;
    Vector lines = new Vector();

    System.err.println(dir+" is requested "); 
    //insert first requested directory name
    lines.addElement(dir);

    //check that this directory exists first
    File file = new File(dir);
    try{
      if (file.exists())
	isExist = true;
      isRead = true;
    }catch(SecurityException e){
      System.err.println("Security Exception "+e);
    }
    
    if (!isRead){
      System.err.println(dir+" is not readable");
      lines.addElement("total xx");   
      lines.addElement("NotReadable");
    }
    else if (!isExist){
      System.err.println(dir+" Not Found");
      lines.addElement("total xx");
      lines.addElement("NotFound");
    }
    if ((!isRead)||(!isExist)){
      System.err.println("file "+dir+" not found or not readable");
      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    }

    try{
      
      String line;
      String  cmd,pwd=null;
      Process child;
      DataInputStream in;

      //start up the command
      cmd = "ls -al "+dir;
      child = Runtime.getRuntime().exec(cmd);
      in = new DataInputStream(child.getInputStream());
      
      //read the command's output
      while((line = in.readLine()) != null)
	lines.addElement(line);

      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    } catch (Exception e){
      throw new InterruptedException (e.toString());
    }
  }

 public void send(String message,ObjectOutputStream dos)
  {
    System.out.println("Outgoing String:"+message);
    try{
      dos.writeObject(message);
      dos.flush();
    }catch(OptionalDataException e){
      System.out.println("sendWFECommand "+e);
    }catch(IOException e){
      System.out.println("sendWFECommand "+e);
    }
  }

  public String receive(ObjectInputStream dis)
  {
    Object message = null;
    
    try{
      message = dis.readObject();
     }catch(OptionalDataException e){
      System.out.println("recvWFEMessage "+e);
    }catch(ClassNotFoundException e){
      System.out.println("recvWFEMessage "+e);
    }catch(IOException e){
      System.out.println("recvWFEMessage "+e);
    }
     System.out.println("I received :"+(String)message);
    return((String)message);
  }


 String readFile(String fileName)
   {
     System.out.println("I am reading the file:"+fileName);
     
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
     
      return new String(data);
   }
  
 public void  writeFile(String fileName,String fileContent)
   {
     System.out.println("I am writing the file:"+fileName+ 
			" content:"+fileContent);
     
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }

}
  
  

 
